Index: .bzrignore
===================================================================
--- .bzrignore	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ .bzrignore	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -9,4 +9,7 @@
 _link.ld
 ./*.iso
+_link-dlexe.ld
+_link-loader.ld
+_link-shlib.ld
 
 ./tools/__pycache__/
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ boot/Makefile.common	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -157,4 +157,5 @@
 	$(USPACE_PATH)/app/usbinfo/usbinfo \
 	$(USPACE_PATH)/app/vuhid/vuh \
+	$(USPACE_PATH)/app/mkbd/mkbd \
 	$(USPACE_PATH)/app/websrv/websrv
 
Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ boot/arch/amd64/Makefile.inc	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -49,5 +49,4 @@
 	usbflbk \
 	usbhub \
-	usbkbd \
 	usbhid \
 	usbmast \
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/Makefile	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -59,4 +59,5 @@
 	app/websrv \
 	app/sysinfo \
+	app/mkbd \
 	srv/clip \
 	srv/devmap \
@@ -122,5 +123,4 @@
 		drv/uhci-rhd \
 		drv/usbflbk \
-		drv/usbkbd \
 		drv/usbhid \
 		drv/usbhub \
@@ -144,5 +144,4 @@
 		drv/uhci-rhd \
 		drv/usbflbk \
-		drv/usbkbd \
 		drv/usbhid \
 		drv/usbhub \
Index: uspace/app/lsusb/main.c
===================================================================
--- uspace/app/lsusb/main.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/app/lsusb/main.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -44,5 +44,5 @@
 #include <devman.h>
 #include <devmap.h>
-#include <usb/hub.h>
+#include <usb/dev/hub.h>
 #include <usb/host.h>
 
Index: uspace/app/mkbd/Makefile
===================================================================
--- uspace/app/mkbd/Makefile	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
+++ uspace/app/mkbd/Makefile	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -0,0 +1,44 @@
+#
+# Copyright (c) 2011 Vojtech Horky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+BINARY = mkbd
+
+LIBS = \
+	$(LIBUSBDEV_PREFIX)/libusbdev.a \
+	$(LIBUSB_PREFIX)/libusb.a \
+	$(LIBDRV_PREFIX)/libdrv.a
+EXTRA_CFLAGS = \
+	-I$(LIBUSB_PREFIX)/include \
+	-I$(LIBUSBDEV_PREFIX)/include \
+	-I$(LIBDRV_PREFIX)/include
+
+SOURCES = \
+	main.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/mkbd/main.c
===================================================================
--- uspace/app/mkbd/main.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
+++ uspace/app/mkbd/main.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -0,0 +1,299 @@
+/*
+ * Copyright (c) 2011 Lubos Slovak
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup mkbd
+ * @{
+ */
+/**
+ * @file
+ * Sample application using the data from multimedia keys on keyboard
+ */
+
+#include <inttypes.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <errno.h>
+#include <str_error.h>
+#include <bool.h>
+#include <getopt.h>
+#include <devman.h>
+#include <devmap.h>
+#include <usb/dev/hub.h>
+#include <usb/host.h>
+#include <usb/driver.h>
+#include <usb/dev/pipes.h>
+
+#define NAME "mkbd"
+
+static int dev_phone = -1;
+
+//static void print_found_hc(size_t class_index, const char *path)
+//{
+//	// printf(NAME ": host controller %zu is `%s'.\n", class_index, path);
+//	printf("Bus %02zu: %s\n", class_index, path);
+//}
+//static void print_found_dev(usb_address_t addr, const char *path)
+//{
+//	// printf(NAME ":     device with address %d is `%s'.\n", addr, path);
+//	printf("  Device %02d: %s\n", addr, path);
+//}
+
+//static void print_hc_devices(devman_handle_t hc_handle)
+//{
+//	int rc;
+//	usb_hc_connection_t conn;
+
+//	usb_hc_connection_initialize(&conn, hc_handle);
+//	rc = usb_hc_connection_open(&conn);
+//	if (rc != EOK) {
+//		printf(NAME ": failed to connect to HC: %s.\n",
+//		    str_error(rc));
+//		return;
+//	}
+//	usb_address_t addr;
+//	for (addr = 1; addr < 5; addr++) {
+//		devman_handle_t dev_handle;
+//		rc = usb_hc_get_handle_by_address(&conn, addr, &dev_handle);
+//		if (rc != EOK) {
+//			continue;
+//		}
+//		char path[MAX_PATH_LENGTH];
+//		rc = devman_get_device_path(dev_handle, path, MAX_PATH_LENGTH);
+//		if (rc != EOK) {
+//			continue;
+//		}
+//		print_found_dev(addr, path);
+//	}
+//	usb_hc_connection_close(&conn);
+//}
+
+static bool try_parse_class_and_address(const char *path,
+    devman_handle_t *out_hc_handle, usb_address_t *out_device_address)
+{
+	size_t class_index;
+	size_t address;
+	int rc;
+	char *ptr;
+
+	rc = str_size_t(path, &ptr, 10, false, &class_index);
+	if (rc != EOK) {
+		return false;
+	}
+	if ((*ptr == ':') || (*ptr == '.')) {
+		ptr++;
+	} else {
+		return false;
+	}
+	rc = str_size_t(ptr, NULL, 10, true, &address);
+	if (rc != EOK) {
+		return false;
+	}
+	rc = usb_ddf_get_hc_handle_by_class(class_index, out_hc_handle);
+	if (rc != EOK) {
+		return false;
+	}
+	if (out_device_address != NULL) {
+		*out_device_address = (usb_address_t) address;
+	}
+	return true;
+}
+
+static bool resolve_hc_handle_and_dev_addr(const char *devpath,
+    devman_handle_t *out_hc_handle, usb_address_t *out_device_address)
+{
+	int rc;
+
+	/* Hack for QEMU to save-up on typing ;-). */
+	if (str_cmp(devpath, "qemu") == 0) {
+		devpath = "/hw/pci0/00:01.2/uhci-rh/usb00_a1";
+	}
+
+	/* Hack for virtual keyboard. */
+	if (str_cmp(devpath, "virt") == 0) {
+		devpath = "/virt/usbhc/usb00_a1/usb00_a2";
+	}
+
+	if (try_parse_class_and_address(devpath,
+	    out_hc_handle, out_device_address)) {
+		return true;
+	}
+
+	char *path = str_dup(devpath);
+	if (path == NULL) {
+		return ENOMEM;
+	}
+
+	devman_handle_t hc = 0;
+	bool hc_found = false;
+	usb_address_t addr = 0;
+	bool addr_found = false;
+
+	/* Remove suffixes and hope that we will encounter device node. */
+	while (str_length(path) > 0) {
+		/* Get device handle first. */
+		devman_handle_t dev_handle;
+		rc = devman_device_get_handle(path, &dev_handle, 0);
+		if (rc != EOK) {
+			free(path);
+			return false;
+		}
+
+		/* Try to find its host controller. */
+		if (!hc_found) {
+			rc = usb_hc_find(dev_handle, &hc);
+			if (rc == EOK) {
+				hc_found = true;
+			}
+		}
+		/* Try to get its address. */
+		if (!addr_found) {
+			addr = usb_device_get_assigned_address(dev_handle);
+			if (addr >= 0) {
+				addr_found = true;
+			}
+		}
+
+		/* Speed-up. */
+		if (hc_found && addr_found) {
+			break;
+		}
+
+		/* Remove the last suffix. */
+		char *slash_pos = str_rchr(path, '/');
+		if (slash_pos != NULL) {
+			*slash_pos = 0;
+		}
+	}
+
+	free(path);
+
+	if (hc_found && addr_found) {
+		if (out_hc_handle != NULL) {
+			*out_hc_handle = hc;
+		}
+		if (out_device_address != NULL) {
+			*out_device_address = addr;
+		}
+		return true;
+	} else {
+		return false;
+	}
+}
+
+static void print_usage(char *app_name)
+{
+#define _INDENT "      "
+
+	printf(NAME ": Print out what multimedia keys were pressed.\n\n");
+	printf("Usage: %s device\n", app_name);
+	printf(_INDENT "The device is a devman path to the device.\n");
+
+#undef _OPTION
+#undef _INDENT
+}
+
+int main(int argc, char *argv[])
+{
+	
+	if (argc <= 1) {
+		print_usage(argv[0]);
+		return -1;
+	}
+	
+	char *devpath = argv[1];
+
+	/* The initialization is here only to make compiler happy. */
+	devman_handle_t hc_handle = 0;
+	usb_address_t dev_addr = 0;
+	bool found = resolve_hc_handle_and_dev_addr(devpath,
+	    &hc_handle, &dev_addr);
+	if (!found) {
+		fprintf(stderr, NAME ": device `%s' not found "
+		    "or not of USB kind. Exiting.\n", devpath);
+		return -1;
+	}
+	
+	int rc;
+	usb_hc_connection_t conn;
+
+	usb_hc_connection_initialize(&conn, hc_handle);
+	rc = usb_hc_connection_open(&conn);
+	if (rc != EOK) {
+		printf(NAME ": failed to connect to HC: %s.\n",
+		    str_error(rc));
+		return -1;
+	}
+	usb_address_t addr = 0;
+
+	devman_handle_t dev_handle;
+	rc = usb_hc_get_handle_by_address(&conn, addr, &dev_handle);
+	if (rc != EOK) {
+		printf(NAME ": failed getting handle to the device: %s.\n",
+		       str_error(rc));
+		return -1;
+	}
+
+	usb_hc_connection_close(&conn);
+	
+	rc = devman_device_connect(dev_handle, 0);
+	if (rc < 0) {
+		printf(NAME ": failed to connect to the device: %s.\n",
+		       str_error(rc));
+		return -1;
+	}
+	
+	dev_phone = rc;
+	printf("Got phone to the device: %d\n", dev_phone);
+	
+	
+//	size_t class_index = 0;
+//	size_t failed_attempts = 0;
+
+//	while (failed_attempts < MAX_FAILED_ATTEMPTS) {
+//		class_index++;
+//		devman_handle_t hc_handle = 0;
+//		int rc = usb_ddf_get_hc_handle_by_class(class_index, &hc_handle);
+//		if (rc != EOK) {
+//			failed_attempts++;
+//			continue;
+//		}
+//		char path[MAX_PATH_LENGTH];
+//		rc = devman_get_device_path(hc_handle, path, MAX_PATH_LENGTH);
+//		if (rc != EOK) {
+//			continue;
+//		}
+//		print_found_hc(class_index, path);
+//		print_hc_devices(hc_handle);
+//	}
+	
+	return 0;
+}
+
+
+/** @}
+ */
Index: uspace/app/usbinfo/desctree.c
===================================================================
--- uspace/app/usbinfo/desctree.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/app/usbinfo/desctree.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -47,5 +47,5 @@
 
 #include "usbinfo.h"
-#include <usb/dp.h>
+#include <usb/dev/dp.h>
 
 static void browse_descriptor_tree_internal(usb_dp_parser_t *parser,
Index: uspace/app/usbinfo/dev.c
===================================================================
--- uspace/app/usbinfo/dev.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/app/usbinfo/dev.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -34,8 +34,8 @@
  * Representation of queried device.
  */
-#include <usb/pipes.h>
+#include <usb/dev/pipes.h>
 #include <errno.h>
 #include <str_error.h>
-#include <usb/request.h>
+#include <usb/dev/request.h>
 #include "usbinfo.h"
 
Index: uspace/app/usbinfo/dump.c
===================================================================
--- uspace/app/usbinfo/dump.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/app/usbinfo/dump.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -47,5 +47,5 @@
 
 #include "usbinfo.h"
-#include <usb/dp.h>
+#include <usb/dev/dp.h>
 
 #define INDENT "  "
Index: uspace/app/usbinfo/info.c
===================================================================
--- uspace/app/usbinfo/info.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/app/usbinfo/info.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -37,7 +37,7 @@
 #include <str_error.h>
 #include <errno.h>
-#include <usb/pipes.h>
-#include <usb/recognise.h>
-#include <usb/request.h>
+#include <usb/dev/pipes.h>
+#include <usb/dev/recognise.h>
+#include <usb/dev/request.h>
 #include <usb/classes/classes.h>
 #include <usb/classes/hub.h>
Index: uspace/app/usbinfo/main.c
===================================================================
--- uspace/app/usbinfo/main.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/app/usbinfo/main.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -43,6 +43,6 @@
 #include <devman.h>
 #include <devmap.h>
-#include <usb/usbdevice.h>
-#include <usb/pipes.h>
+#include <usb/dev/hc.h>
+#include <usb/dev/pipes.h>
 #include <usb/host.h>
 #include <usb/driver.h>
Index: uspace/app/usbinfo/usbinfo.h
===================================================================
--- uspace/app/usbinfo/usbinfo.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/app/usbinfo/usbinfo.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -38,7 +38,7 @@
 #include <usb/usb.h>
 #include <usb/descriptor.h>
-#include <usb/pipes.h>
+#include <usb/dev/pipes.h>
 #include <usb/debug.h>
-#include <usb/dp.h>
+#include <usb/dev/dp.h>
 #include <ipc/devman.h>
 
Index: uspace/app/vuhid/hids/bootkbd.c
===================================================================
--- uspace/app/vuhid/hids/bootkbd.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/app/vuhid/hids/bootkbd.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -36,6 +36,6 @@
 #include <errno.h>
 #include <usb/debug.h>
-#include <usb/classes/hid.h>
-#include <usb/classes/hidut.h>
+#include <usb/hid/hid.h>
+#include <usb/hid/usages/core.h>
 
 #include "../report.h"
Index: uspace/app/vuhid/main.c
===================================================================
--- uspace/app/vuhid/main.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/app/vuhid/main.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -45,5 +45,5 @@
 #include <usb/debug.h>
 #include <usb/classes/classes.h>
-#include <usb/classes/hid.h>
+#include <usb/hid/hid.h>
 #include <usbvirt/device.h>
 
Index: uspace/doc/doxygroups.h
===================================================================
--- uspace/doc/doxygroups.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/doc/doxygroups.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -172,7 +172,26 @@
  */
 	/**
-	 * @defgroup libusb USB library
-	 * @ingroup usb
-	 * @brief Library for creating USB devices drivers.
+	 * @defgroup libusb Base USB library
+	 * @ingroup usb
+	 * @brief Common definitions for any driver or application
+	 * dealing with USB.
+	 */
+
+	/**
+	 * @defgroup libusbdev USB library for device drivers
+	 * @ingroup usb
+	 * @brief Library for writing drivers of endpoint devices (functions).
+	 */
+
+	/**
+	 * @defgroup libusbhost USB library for host controller drivers
+	 * @ingroup usb
+	 * @brief Library for writing host controller drivers.
+	 */
+
+	/**
+	 * @defgroup libusbhid USB library for HID devices
+	 * @ingroup usb
+	 * @brief Library for writing USB HID drivers.
 	 */
 
Index: uspace/drv/ohci/root_hub.c
===================================================================
--- uspace/drv/ohci/root_hub.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/ohci/root_hub.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -39,9 +39,9 @@
 
 #include "root_hub.h"
-#include "usb/classes/classes.h"
-#include "usb/devdrv.h"
+#include <usb/classes/classes.h>
+#include <usb/dev/driver.h>
 #include "ohci_regs.h"
 
-#include <usb/request.h>
+#include <usb/dev/request.h>
 #include <usb/classes/hub.h>
 
Index: uspace/drv/ohci/root_hub.h
===================================================================
--- uspace/drv/ohci/root_hub.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/ohci/root_hub.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -36,5 +36,5 @@
 
 #include <usb/usb.h>
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 
 #include "ohci_regs.h"
Index: uspace/drv/uhci-rhd/port.c
===================================================================
--- uspace/drv/uhci-rhd/port.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/uhci-rhd/port.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -40,5 +40,5 @@
 
 #include <usb/usb.h>    /* usb_address_t */
-#include <usb/hub.h>    /* usb_hc_new_device_wrapper */
+#include <usb/dev/hub.h>    /* usb_hc_new_device_wrapper */
 #include <usb/debug.h>
 
Index: uspace/drv/uhci-rhd/port.h
===================================================================
--- uspace/drv/uhci-rhd/port.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/uhci-rhd/port.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -38,5 +38,5 @@
 #include <fibril.h>
 #include <ddf/driver.h>
-#include <usb/usbdevice.h> /* usb_hc_connection_t */
+#include <usb/dev/hc.h> /* usb_hc_connection_t */
 
 typedef uint16_t port_status_t;
Index: uspace/drv/usbflbk/main.c
===================================================================
--- uspace/drv/usbflbk/main.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbflbk/main.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -34,5 +34,5 @@
  * Main routines of USB fallback driver.
  */
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 #include <usb/debug.h>
 #include <errno.h>
Index: uspace/drv/usbhid/Makefile
===================================================================
--- uspace/drv/usbhid/Makefile	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhid/Makefile	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -57,6 +57,6 @@
 	generic/hiddev.c \
 	mouse/mousedev.c \
-	lgtch-ultrax/lgtch-ultrax.c \
-	lgtch-ultrax/keymap.c \
+	multimedia/multimedia.c \
+	multimedia/keymap.c \
 	$(STOLEN_LAYOUT_SOURCES)
 
Index: uspace/drv/usbhid/generic/hiddev.c
===================================================================
--- uspace/drv/usbhid/generic/hiddev.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhid/generic/hiddev.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -162,5 +162,5 @@
 /*----------------------------------------------------------------------------*/
 
-int usb_generic_hid_init(usb_hid_dev_t *hid_dev)
+int usb_generic_hid_init(usb_hid_dev_t *hid_dev, void **data)
 {
 	if (hid_dev == NULL) {
@@ -173,5 +173,5 @@
 /*----------------------------------------------------------------------------*/
 
-bool usb_generic_hid_polling_callback(usb_hid_dev_t *hid_dev, 
+bool usb_generic_hid_polling_callback(usb_hid_dev_t *hid_dev, void *data, 
     uint8_t *buffer, size_t buffer_size)
 {
Index: uspace/drv/usbhid/generic/hiddev.h
===================================================================
--- uspace/drv/usbhid/generic/hiddev.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhid/generic/hiddev.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -37,5 +37,5 @@
 #define USB_HID_HIDDDEV_H_
 
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 
 struct usb_hid_dev;
@@ -48,7 +48,7 @@
 /*----------------------------------------------------------------------------*/
 
-int usb_generic_hid_init(struct usb_hid_dev *hid_dev);
+int usb_generic_hid_init(struct usb_hid_dev *hid_dev, void **data);
 
-bool usb_generic_hid_polling_callback(struct usb_hid_dev *hid_dev,
+bool usb_generic_hid_polling_callback(struct usb_hid_dev *hid_dev, void *data,
     uint8_t *buffer, size_t buffer_size);
 
Index: uspace/drv/usbhid/kbd/kbddev.c
===================================================================
--- uspace/drv/usbhid/kbd/kbddev.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhid/kbd/kbddev.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -46,17 +46,17 @@
 
 #include <usb/usb.h>
-#include <usb/dp.h>
-#include <usb/request.h>
-#include <usb/classes/hid.h>
-#include <usb/pipes.h>
+#include <usb/dev/dp.h>
+#include <usb/dev/request.h>
+#include <usb/hid/hid.h>
+#include <usb/dev/pipes.h>
 #include <usb/debug.h>
-#include <usb/classes/hidparser.h>
+#include <usb/hid/hidparser.h>
 #include <usb/classes/classes.h>
-#include <usb/classes/hidut.h>
-#include <usb/classes/hidreq.h>
-#include <usb/classes/hidreport.h>
-#include <usb/classes/hid/utled.h>
-
-#include <usb/devdrv.h>
+#include <usb/hid/usages/core.h>
+#include <usb/hid/request.h>
+#include <usb/hid/hidreport.h>
+#include <usb/hid/usages/led.h>
+
+#include <usb/dev/driver.h>
 
 #include "kbddev.h"
@@ -252,7 +252,6 @@
 	sysarg_t method = IPC_GET_IMETHOD(*icall);
 	
-	usb_hid_dev_t *hid_dev = (usb_hid_dev_t *)fun->driver_data;
-	
-	if (hid_dev == NULL || hid_dev->data == NULL) {
+	usb_kbd_t *kbd_dev = (usb_kbd_t *)fun->driver_data;
+	if (kbd_dev == NULL) {
 		usb_log_debug("default_connection_handler: "
 		    "Missing parameter.\n");
@@ -260,8 +259,4 @@
 		return;
 	}
-	
-	assert(hid_dev != NULL);
-	assert(hid_dev->data != NULL);
-	usb_kbd_t *kbd_dev = (usb_kbd_t *)hid_dev->data;
 
 	if (method == IPC_M_CONNECT_TO_ME) {
@@ -313,9 +308,9 @@
 	usb_hid_report_field_t *field = usb_hid_report_get_sibling(
 	    hid_dev->report, NULL, kbd_dev->led_path, 
-	    USB_HID_PATH_COMPARE_USAGE_PAGE_ONLY | USB_HID_PATH_COMPARE_END,
+	    USB_HID_PATH_COMPARE_END | USB_HID_PATH_COMPARE_USAGE_PAGE_ONLY,
 	    USB_HID_REPORT_TYPE_OUTPUT);
 	
-	while (field != NULL) {
-
+	while (field != NULL) {		
+		
 		if ((field->usage == USB_HID_LED_NUM_LOCK) 
 		    && (kbd_dev->mods & KM_NUM_LOCK)){
@@ -334,6 +329,7 @@
 		
 		field = usb_hid_report_get_sibling(hid_dev->report, field,
-		    kbd_dev->led_path, USB_HID_PATH_COMPARE_USAGE_PAGE_ONLY 
-		    | USB_HID_PATH_COMPARE_END, USB_HID_REPORT_TYPE_OUTPUT);
+		    kbd_dev->led_path,  
+	    	USB_HID_PATH_COMPARE_END | USB_HID_PATH_COMPARE_USAGE_PAGE_ONLY,
+			USB_HID_REPORT_TYPE_OUTPUT);
 	}
 	
@@ -662,12 +658,10 @@
  *     usb_hid_parse_report().
  */
-static void usb_kbd_process_data(usb_hid_dev_t *hid_dev,
+static void usb_kbd_process_data(usb_hid_dev_t *hid_dev, usb_kbd_t *kbd_dev,
                                  uint8_t *buffer, size_t actual_size)
 {
 	assert(hid_dev->report != NULL);
 	assert(hid_dev != NULL);
-	assert(hid_dev->data != NULL);
-	
-	usb_kbd_t *kbd_dev = (usb_kbd_t *)hid_dev->data;
+	assert(kbd_dev != NULL);
 
 	usb_log_debug("Calling usb_hid_parse_report() with "
@@ -774,8 +768,9 @@
 /*----------------------------------------------------------------------------*/
 
-static int usb_kbd_create_function(usb_hid_dev_t *hid_dev)
+static int usb_kbd_create_function(usb_hid_dev_t *hid_dev, usb_kbd_t *kbd_dev)
 {
 	assert(hid_dev != NULL);
 	assert(hid_dev->usb_dev != NULL);
+	assert(kbd_dev != NULL);
 	
 	/* Create the function exposed under /dev/devices. */
@@ -792,6 +787,6 @@
 	 * to the DDF function.
 	 */
-	fun->ops = &hid_dev->ops;
-	fun->driver_data = hid_dev;   // TODO: maybe change to hid_dev->data
+	fun->ops = &kbd_dev->ops;
+	fun->driver_data = kbd_dev;
 
 	int rc = ddf_fun_bind(fun);
@@ -840,5 +835,5 @@
  * @return Other value inherited from function usbhid_dev_init().
  */
-int usb_kbd_init(usb_hid_dev_t *hid_dev)
+int usb_kbd_init(usb_hid_dev_t *hid_dev, void **data)
 {
 	usb_log_debug("Initializing HID/KBD structure...\n");
@@ -865,7 +860,6 @@
 	usb_hid_report_path_set_report_id(path, 0);
 	
-	kbd_dev->key_count = usb_hid_report_input_length(
-	    hid_dev->report, path, 
-	    USB_HID_PATH_COMPARE_END | USB_HID_PATH_COMPARE_USAGE_PAGE_ONLY);
+	kbd_dev->key_count = usb_hid_report_size(
+	    hid_dev->report, 0, USB_HID_REPORT_TYPE_INPUT); 
 	usb_hid_report_path_free(path);
 	
@@ -908,7 +902,6 @@
 	    kbd_dev->led_path, USB_HIDUT_PAGE_LED, 0);
 	
-	kbd_dev->led_output_size = usb_hid_report_output_size(hid_dev->report, 
-	    kbd_dev->led_path, 
-	    USB_HID_PATH_COMPARE_END | USB_HID_PATH_COMPARE_USAGE_PAGE_ONLY);
+	kbd_dev->led_output_size = usb_hid_report_size(hid_dev->report, 
+	    0, USB_HID_REPORT_TYPE_OUTPUT);
 	
 	usb_log_debug("Output report size (in items): %zu\n", 
@@ -955,8 +948,9 @@
 	
 	// save the KBD device structure into the HID device structure
-	hid_dev->data = kbd_dev;
+	//hid_dev->data = kbd_dev;
+	*data = kbd_dev;
 	
 	// set handler for incoming calls
-	hid_dev->ops.default_handler = default_connection_handler;
+	kbd_dev->ops.default_handler = default_connection_handler;
 	
 	/*
@@ -983,5 +977,5 @@
 	
 	usb_log_debug("Creating KBD function...\n");
-	int rc = usb_kbd_create_function(hid_dev);
+	int rc = usb_kbd_create_function(hid_dev, kbd_dev);
 	if (rc != EOK) {
 		usb_kbd_free(&kbd_dev);
@@ -994,14 +988,17 @@
 /*----------------------------------------------------------------------------*/
 
-bool usb_kbd_polling_callback(usb_hid_dev_t *hid_dev, uint8_t *buffer,
-     size_t buffer_size)
-{
-	if (hid_dev == NULL || buffer == NULL) {
+bool usb_kbd_polling_callback(usb_hid_dev_t *hid_dev, void *data, 
+     uint8_t *buffer, size_t buffer_size)
+{
+	if (hid_dev == NULL || buffer == NULL || data == NULL) {
 		// do not continue polling (???)
 		return false;
 	}
 	
+	usb_kbd_t *kbd_dev = (usb_kbd_t *)data;
+	assert(kbd_dev != NULL);
+	
 	// TODO: add return value from this function
-	usb_kbd_process_data(hid_dev, buffer, buffer_size);
+	usb_kbd_process_data(hid_dev, kbd_dev, buffer, buffer_size);
 	
 	return true;
@@ -1066,5 +1063,5 @@
 /*----------------------------------------------------------------------------*/
 
-void usb_kbd_deinit(usb_hid_dev_t *hid_dev)
+void usb_kbd_deinit(usb_hid_dev_t *hid_dev, void *data)
 {
 	if (hid_dev == NULL) {
@@ -1072,11 +1069,10 @@
 	}
 	
-	if (hid_dev->data != NULL) {
-		usb_kbd_t *kbd_dev = (usb_kbd_t *)hid_dev->data;
+	if (data != NULL) {
+		usb_kbd_t *kbd_dev = (usb_kbd_t *)data;
 		if (usb_kbd_is_initialized(kbd_dev)) {
 			usb_kbd_mark_unusable(kbd_dev);
 		} else {
 			usb_kbd_free(&kbd_dev);
-			hid_dev->data = NULL;
 		}
 	}
Index: uspace/drv/usbhid/kbd/kbddev.h
===================================================================
--- uspace/drv/usbhid/kbd/kbddev.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhid/kbd/kbddev.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -41,9 +41,9 @@
 #include <fibril_synch.h>
 
-#include <usb/classes/hid.h>
-#include <usb/classes/hidparser.h>
+#include <usb/hid/hid.h>
+#include <usb/hid/hidparser.h>
 #include <ddf/driver.h>
-#include <usb/pipes.h>
-#include <usb/devdrv.h>
+#include <usb/dev/pipes.h>
+#include <usb/dev/driver.h>
 
 #include "kbdrepeat.h"
@@ -83,4 +83,7 @@
 	int console_phone;
 	
+	/** @todo What is this actually? */
+	ddf_dev_ops_t ops;
+	
 	/** Information for auto-repeat of keys. */
 	usb_kbd_repeat_t repeat;
@@ -117,8 +120,8 @@
 /*----------------------------------------------------------------------------*/
 
-int usb_kbd_init(struct usb_hid_dev *hid_dev);
+int usb_kbd_init(struct usb_hid_dev *hid_dev, void **data);
 
-bool usb_kbd_polling_callback(struct usb_hid_dev *hid_dev, uint8_t *buffer,
-    size_t buffer_size);
+bool usb_kbd_polling_callback(struct usb_hid_dev *hid_dev, void *data, 
+                              uint8_t *buffer, size_t buffer_size);
 
 int usb_kbd_is_initialized(const usb_kbd_t *kbd_dev);
@@ -131,5 +134,5 @@
     int type, unsigned int key);
 
-void usb_kbd_deinit(struct usb_hid_dev *hid_dev);
+void usb_kbd_deinit(struct usb_hid_dev *hid_dev, void *data);
 
 int usb_kbd_set_boot_protocol(struct usb_hid_dev *hid_dev);
Index: uspace/drv/usbhid/kbd/main.c
===================================================================
--- uspace/drv/usbhid/kbd/main.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhid/kbd/main.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -41,5 +41,5 @@
 #include <str_error.h>
 
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 
 #include "kbddev.h"
Index: uspace/drv/usbhid/main.c
===================================================================
--- uspace/drv/usbhid/main.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhid/main.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -41,6 +41,6 @@
 #include <str_error.h>
 
-#include <usb/devdrv.h>
-#include <usb/devpoll.h>
+#include <usb/dev/driver.h>
+#include <usb/dev/poll.h>
 
 #include "usbhid.h"
